/*
 * Universidade Federal de Pernambuco - UFPE
 * Centro de Informtica - CIn
 * Disciplina: Sistemas Inteligentes
 * 
 * Alunos:
 * Hallan Cosmo - hcs
 * Leandro Henrique - lheva
 * Rodrigo Cavalcanti - rpcs
 * 
 * Professor: Fred Freitas
 */

import jess.*;
import java.util.*;
import java.text.*;

public class Agencia{
	
	private static int DEST_NUM = 9;
	private static int HOTEL_NUM = 5;
	private static int TRANSP_NUM = 10;
	private static int TOUR_NUM = 2;
	private DecimalFormat format;
	
	private int cost_dest[] = { 500,4000,3000,5000,100,7000,6500,5000,10000 };
	private int cost_hotel[] = { 200,500,2000,10000,50000 };
	private int cost_transp[] = { 5000,300,2000,10000,1000,7000,12000,15000,20000,50000 };
	private int cost_tour[] = { 0, 10000 };
	
	Rete rete_start,rete_print,rete,rete_process;
	Cliente cliente;
	Console c;
	
	public Agencia(){
		rete_start = new Rete();
		rete_print = new Rete();
		rete_process = new Rete();
			
		rete = new Rete();
		c = new Console();
		format = new DecimalFormat("#####.##");
	}
	
	public int knapsack_jess() throws JessException{
		
		int custo_atual;
		int best = -1;
		int i,j,k,l;
		
		rete_process.executeCommand("(defquery search (declare (variables ?Y)) (destino ?X ?Y ?Z))");
	    
	    rete_process.reset();
	    rete_process.store("RESULT", rete_process.runQuery("search",
	                      new ValueVector().add(new Value("\"" + cliente.getDestino()+ "\"", RU.ATOM))));
	     
	    rete_process.executeCommand("(store RESULT (run-query search "+ "\""+cliente.getDestino()+"\""+ "))");

	    // Guarda o resultado no Iterator
	    Iterator e = (Iterator) rete_process.fetch("RESULT").externalAddressValue(null);
	    ArrayList v = new ArrayList();

	      
	    // Pega cada elemento do Iterator e armazena num ArrayList
	    while (e.hasNext()){
	        Token t = (Token) e.next();
	        // Pega o segundo fato no Token - O primeiro  a query trigger
	        Fact f = t.fact(1);
	        // O Primeiro e unico slot deste fato  o __data multislot.
	        ValueVector multislot = f.get(0).listValue(null);
	        //O segundo elemento deste slot  o datum, estamos interessados nele.
	        v.add(multislot.get(2).stringValue(null));
	    }
	    
	    Iterator answers = v.iterator();
	    
	    int c = Integer.parseInt((answers.next().toString()));
	    
		for(j=0;j<HOTEL_NUM;j++){
			for(k=0;k<TRANSP_NUM;k++){
				for(l=0;l<TOUR_NUM;l++){
					custo_atual = c + cost_hotel[j] + cost_transp[k] + cost_tour[l];
					if( custo_atual <= cliente.getCapital() ){
						if(custo_atual > best){
							
							best = custo_atual;
							
							// ------------
													    
						    
						    rete_process.executeCommand("(defquery search (declare (variables ?Y)) (hotel ?X ?Y))");
						    
						    rete_process.reset();
						    
						    rete_process.store("RESULT", rete_process.runQuery("search",
						                      new ValueVector().add(new Value(cost_hotel[j], RU.INTEGER))));
						     
						    rete_process.executeCommand("(store RESULT (run-query search "+cost_hotel[j]+ "))");

						    e = (Iterator) rete_process.fetch("RESULT").externalAddressValue(null);
						    v = new ArrayList();

						      
						    while (e.hasNext()){
						        Token t = (Token) e.next();
						        Fact f = t.fact(1);
						        ValueVector multislot = f.get(0).listValue(null);
						        v.add(multislot.get(0).stringValue(null));
						    }
						    
						    answers = v.iterator();
						    cliente.setHotel(answers.next().toString());
						    
						    //-----------
						    
						    rete_process.executeCommand("(defquery search (declare (variables ?Y)) (transporte ?X ?Y))");
						    
						    rete_process.reset();
						    
						    rete_process.store("RESULT", rete_process.runQuery("search",
						                      new ValueVector().add(new Value(cost_transp[k], RU.INTEGER))));
						     
						    rete_process.executeCommand("(store RESULT (run-query search "+ cost_transp[k]+"))");

						    e = (Iterator) rete_process.fetch("RESULT").externalAddressValue(null);
						    v = new ArrayList();

						    while (e.hasNext()){
						        Token t = (Token) e.next();
						        Fact f = t.fact(1);
						        ValueVector multislot = f.get(0).listValue(null);
						        v.add(multislot.get(0).stringValue(null));
						    }
						    
						    answers = v.iterator();
						    cliente.setTransporte(answers.next().toString());
						    
						    
						    if(l==0) cliente.setCity_tour(false);
						    else     cliente.setCity_tour(true);
						    
						    cliente.setProposta(best);
						}
					}
				}
			}
		}
		
		if( best != -1 ) return best;
		
		String escolha = cliente.getDestino();
		
		for(k=0;k<TRANSP_NUM;k++){
			for(j=0;j<HOTEL_NUM;j++){
				for(i=0;i<DEST_NUM;i++){
					for(l=0;l<TOUR_NUM;l++){
						custo_atual = cost_dest[i] + cost_hotel[j] + cost_transp[k] + cost_tour[l];
						if( custo_atual <= cliente.getCapital() ){
							if(custo_atual > best){
								
								best = custo_atual;
								
								// ------------
								
								rete_process.executeCommand("(defquery search (declare (variables ?Z)) (destino ?X ?Y ?Z))");
							    
							    rete_process.reset();
							    rete_process.store("RESULT", rete_process.runQuery("search",
							                      new ValueVector().add(new Value(cost_dest[i], RU.INTEGER))));
							     
							    rete_process.executeCommand("(store RESULT (run-query search "+ cost_dest[i]+"))");

							    e = (Iterator) rete_process.fetch("RESULT").externalAddressValue(null);
							    v = new ArrayList();

							    while (e.hasNext()){
							        Token t = (Token) e.next();
							        Fact f = t.fact(1);
							        ValueVector multislot = f.get(0).listValue(null);
							        v.add(multislot.get(1).stringValue(null));
							    
							    answers = v.iterator();
							    cliente.setDestino(answers.next().toString());
							    
							    //------------
							    
							    
							    rete_process.executeCommand("(defquery search (declare (variables ?Y)) (hotel ?X ?Y))");
							    
							    rete_process.reset();
							    
							    rete_process.store("RESULT", rete_process.runQuery("search",
							                      new ValueVector().add(new Value(cost_hotel[j], RU.INTEGER))));
							     
							    rete_process.executeCommand("(store RESULT (run-query search "+cost_hotel[j]+ "))");

							    e = (Iterator) rete_process.fetch("RESULT").externalAddressValue(null);
							    v = new ArrayList();

							      
							    while (e.hasNext()){
							        t = (Token) e.next();
							        f = t.fact(1);
							        multislot = f.get(0).listValue(null);
							        v.add(multislot.get(0).stringValue(null));
							    }
							    
							    answers = v.iterator();
							    cliente.setHotel(answers.next().toString());
							    
							    //-----------
							    
							    rete_process.executeCommand("(defquery search (declare (variables ?Y)) (transporte ?X ?Y))");
							    
							    rete_process.reset();
							    
							    rete_process.store("RESULT", rete_process.runQuery("search",
							                      new ValueVector().add(new Value(cost_transp[k], RU.INTEGER))));
							     
							    rete_process.executeCommand("(store RESULT (run-query search "+ cost_transp[k]+"))");

							    e = (Iterator) rete_process.fetch("RESULT").externalAddressValue(null);
							    v = new ArrayList();

							    while (e.hasNext()){
							        t = (Token) e.next();
							        f = t.fact(1);
							        multislot = f.get(0).listValue(null);
							        v.add(multislot.get(0).stringValue(null));
							    }
							    
							    answers = v.iterator();
							    cliente.setTransporte(answers.next().toString());
							    
							    
							    if(l==0) cliente.setCity_tour(false);
							    else     cliente.setCity_tour(true);
							    
							    cliente.setProposta(best);
							}
						}
						if(!cliente.getDestino().equals(escolha)) cliente.setChega_destino(false);	
					}
				}
			}
		}
		
		
		
		}
		return best;
	}
	
	public void apresentaAgencia() throws JessException{
        rete_start.executeCommand("(defrule startup \"define initial WMEs created by (reset)\"" +
                              " =>" +
                              "   (printout t \"*** Sistema de Agncia Inteligente CIn - Seja Bem-vindo ***\n\n\") " +
                              "   (printout t \"Sua Viagem planejada do jeito mais inteligente! \n\") " +
                              "   (printout t \"Por favor, aguarde enquanto carregamos nosso sistema...\n\") " +
                              "   (printout t \"Em instantes comearemos a programar sua viagem\n\n\") ) " );
                             
          
        rete_start.reset();
        rete_start.run();
	}
	
	public void carregaRegras() throws JessException{
		
		/*
		 *  Comandos ao Jess para deftemplates
		 */
		rete.executeCommand("(deftemplate destino (slot nome) (slot distancia) (slot type))");
		
		rete.executeCommand("(assert (destino (nome \"Madrid\") (distancia 3500) (type longe)))");
		rete.executeCommand("(assert (destino (nome \"Rio de Janeiro\") (distancia 300) (type perto)))");
		rete.executeCommand("(assert (destino (nome \"New York\") (distancia 1500) (type longe)))");
		rete.executeCommand("(assert (destino (nome \"Washington\") (distancia 2000) (type longe)))");
		rete.executeCommand("(assert (destino (nome \"Melbourne\") (distancia 4500) (type longe)))");
		rete.executeCommand("(assert (destino (nome \"Tokio\") (distancia 6500) (type longe)))");
		rete.executeCommand("(assert (destino (nome \"Paris\") (distancia 4000) (type longe)))");
		rete.executeCommand("(assert (destino (nome \"Caribe\") (distancia 1700) (type medio)))");
		rete.executeCommand("(assert (destino (nome \"Olinda\") (distancia 10) (type perto)))");
		
		rete.executeCommand("(deftemplate hotel (slot nome) (slot estrelas) (slot type))");
		
		rete.executeCommand("(assert (hotel (nome G1) (estrelas 1) (type barato)))");
		rete.executeCommand("(assert (hotel (nome G2) (estrelas 2) (type barato)))");
		rete.executeCommand("(assert (hotel (nome G3) (estrelas 3) (type medio)))");
		rete.executeCommand("(assert (hotel (nome G4) (estrelas 4) (type medio)))");
		rete.executeCommand("(assert (hotel (nome G5) (estrelas 5) (type caro)))");

		
		rete.executeCommand("(deftemplate transporte (slot nome) (slot velocidade) (slot type))");
		
		rete.executeCommand("(assert (transporte (nome Aviao) (velocidade 800) (type aereo)))");
		rete.executeCommand("(assert (transporte (nome Trem) (velocidade 200) (type terrestre)))");
		rete.executeCommand("(assert (transporte (nome Carro) (velocidade 120) (type terrestre)))");
		rete.executeCommand("(assert (transporte (nome Balsa) (velocidade 80) (type aquatico)))");
		rete.executeCommand("(assert (transporte (nome Navio) (velocidade 120) (type aquatico)))");
		
		
		/*
		 *  Comandos ao Jess para deffunction e defrules
		 */
		
		rete.executeCommand("(deffunction change-transporte () (bind ?transp Carro))");
		rete.executeCommand("(deffunction change-hotel () (bind ?hot barato))");
		rete.executeCommand("(deffunction cliente-nao-viaja () (bind ?destino Casa))");
		rete.executeCommand("(deffunction cliente-nao-voa () (bind ?transp Carro))");
		
		
		//se o cliente ta sem dinheiro a gente coloca um transporte mais barato
		rete.executeCommand("(defrule do-change-transporte (cliente-sem-dinheiro-voo) => (change-transporte))");
		
		//ou num hotel mais barato..
		rete.executeCommand("(defrule do-change-hotel (cliente-sem-dinheiro-hotel) => (change-hotel))");		
		
		//se o cliente nao tem dinheiro, ele nao vai pra canto nenhum
		rete.executeCommand("(defrule do-cliente-nao-viaja (cliente-pobre) => (cliente-nao-viaja))");
		
		//se o cliente esta bem proximo do destino ele nao vai de aviao
		rete.executeCommand("(defrule verifica-distancia (destino (distancia ?x)) (test (< ?x 800))" +
				"=>" +
				"(cliente-nao-voa))");

	}
	
	public void lerDados() throws JessException{

		String nome = "";
		String transporte = "";
		String destino = "";
		String data_ida=  "";
		String data_volta = "";
		
		int tempoPartida = 0;
		int tempoChegada = 0;
		
		double capital = 0;
		boolean city_tour = false;
		String hotel = "";
		
		String read;
		
		int opcao;
		
		rete_print.executeCommand("(printout t \"Qual o seu nome? : \")");
		nome = c.readString();
		rete_print.executeCommand("(printout t \"\n\")");

		while(true){
			rete_print.executeCommand("(printout t \"Qual o seu local de destino? : \n\")");
			rete_print.executeCommand("(printout t \"1 - Rio de Janeiro  R$500,00\n\")");
			rete_print.executeCommand("(printout t \"2 - New York        R$4000,00\n\")");
			rete_print.executeCommand("(printout t \"3 - Washington      R$3000,00\n\")");
			rete_print.executeCommand("(printout t \"4 - Caribe          R$5000,00\n\")");
			rete_print.executeCommand("(printout t \"5 - Olinda          R$100,00\n\")");
			rete_print.executeCommand("(printout t \"6 - Paris           R$7000,00\n\")");
			rete_print.executeCommand("(printout t \"7 - Londres         R$6500,00\n\")");
			rete_print.executeCommand("(printout t \"8 - Tokio           R$10000,00\n\")");
			rete_print.executeCommand("(printout t \"9 - Ilhas Cayman    R$5000,00\n\")");
			
			read = c.readString();
			if( String.valueOf(read).length() != 1 || (read.charAt(0) < '0' || read.charAt(0) > '9')) {
				rete_print.executeCommand("(printout t \"escolha uma opcao valida\n\")");
				continue;
			}
			
			opcao = Integer.parseInt(read);
			
			
			
			if( opcao == 1 ) destino = "Rio de Janeiro";
			else if( opcao == 2 ) destino = "New York";
			else if( opcao == 3 ) destino = "Washington";
			else if( opcao == 4 ) destino = "Caribe";
			else if( opcao == 5 ) destino = "Olinda";
			else if( opcao == 6 ) destino = "Paris";
			else if( opcao == 7 ) destino = "Londres";
			else if( opcao == 8 ) destino = "Tokio";
			else if( opcao == 9 ) destino = "Ilhas Cayman";
			else{
				rete_print.executeCommand("(printout t \"escolha uma opcao valida\n\")");
				continue;
			}
			break;
		}
		
		rete_print.executeCommand("(printout t \"\n\")");
		
		while(true){
		
			rete_print.executeCommand("(printout t \"Escolha a sua preferencia de transporte: \n\")");
			rete_print.executeCommand("(printout t \"1 - Areo        (ver opcoes de voo)\n\")");
			rete_print.executeCommand("(printout t \"2 - Trem         R$300,00\n\")");
			rete_print.executeCommand("(printout t \"3 - Carro        R$2000,00\n\")");
			rete_print.executeCommand("(printout t \"4 - Balsa        R$10000,00\n\")");
			rete_print.executeCommand("(printout t \"5 - Motocicleta  R$1000,00\n\")");
			rete_print.executeCommand("(printout t \"6 - Navio        R$5000,00\n\")");
	
			
			read = c.readString();
			if( String.valueOf(read).length() != 1 || (read.charAt(0) < '0' || read.charAt(0) > '9')) {
				rete_print.executeCommand("(printout t \"escolha uma opcao valida\n\")");
				continue;
			}
			
			opcao = Integer.parseInt(read);
			
			if( opcao == 6 ) transporte = "Navio";
			else if( opcao == 5 ) transporte = "Motocicleta";
			else if( opcao == 4 ) transporte = "Balsa";
			else if( opcao == 3 ) transporte = "Carro";
			else if( opcao == 2 ) transporte = "Trem";
			else if( opcao == 1){
				rete_print.executeCommand("(printout t \"\n\")");
				
				rete_print.executeCommand("(printout t \"Qual a sua preferencia de transporte areo: \n\")");
				rete_print.executeCommand("(printout t \"1 - Aviao        R$7000,00\n\")");
				rete_print.executeCommand("(printout t \"2 - Helicoptero  R$12000,00\n\")");
				rete_print.executeCommand("(printout t \"3 - Planador     R$15000,00\n\")");
				rete_print.executeCommand("(printout t \"4 - Balao        R$20000,00\n\")");
				rete_print.executeCommand("(printout t \"5 - Dirigivel    R$50000,00\n\")");
				
				opcao = c.readInt();
				
				if( opcao == 5 ) transporte = "Dirigivel";
				else if( opcao == 4 ) transporte = "Balao";
				else if( opcao == 3 ) transporte = "Planador";
				else if( opcao == 2 ) transporte = "Helicoptero";
				else transporte = "Aviao";
			}
			else{
				rete_print.executeCommand("(printout t escolha uma opcao valida\n)");
				continue;
			}
			break;
		}
		
		
		rete_print.executeCommand("(printout t \"\n\")");
		
		rete_print.executeCommand("(printout t \"Digite a data de Partida: \n\")");
		data_ida = c.readString();
		
		rete_print.executeCommand("(printout t \"\n\")");
				

		rete_print.executeCommand("(printout t \"Digite a data de Chegada: \n\")");
		data_volta = c.readString();
		
		rete_print.executeCommand("(printout t \"\n\")");
		
		while(true){
			rete_print.executeCommand("(printout t \"Deseja fazer um City Tour para conhecer melhor a cidade? : \n\")");
			rete_print.executeCommand("(printout t \"1 - SIM     R$10000,00\n\")");
			rete_print.executeCommand("(printout t \"2 - NO\n\")");

			read = c.readString();
			if( String.valueOf(read).length() != 1 || (read.charAt(0) < '0' || read.charAt(0) > '9')) {
				rete_print.executeCommand("(printout t \"escolha uma opcao valida\n\")");
				continue;
			}
			
			opcao = Integer.parseInt(read);
			
			if(opcao==1) city_tour = true;
			else if(opcao==2)    city_tour = false;
			else{
				rete_print.executeCommand("(printout t \"escolha uma opcao valida\n\")");
				continue;
			}
			
			break;
		}
		
		rete_print.executeCommand("(printout t \"\n\")");
		
        while(true){
        	rete_print.executeCommand("(printout t \"Qual o hotel de sua preferncia: \n\")");
    		rete_print.executeCommand("(printout t \"1 - Hotel G1 *       R$200,00\n\")");
    		rete_print.executeCommand("(printout t \"2 - Hotel G2 **      R$500,00\n\")");
    		rete_print.executeCommand("(printout t \"3 - Hotel G3 ***     R$2000,00\n\")");
    		rete_print.executeCommand("(printout t \"4 - Hotel G4 ****    R$10000,00\n\")");
    		rete_print.executeCommand("(printout t \"5 - Hotel G5 *****   R$50000,00\n\")");
    		
    		read = c.readString();
			if( String.valueOf(read).length() != 1 || (read.charAt(0) < '0' || read.charAt(0) > '9')) {
				rete_print.executeCommand("(printout t \"escolha uma opcao valida\n\")");
				continue;
			}
			
			opcao = Integer.parseInt(read);
    		
    		if( opcao == 5 ) hotel = "Hotel G5";
    		else if( opcao == 4 ) hotel = "Hotel G4";
    		else if( opcao == 3 ) hotel = "Hotel G3";
    		else if( opcao == 2 ) hotel = "Hotel G2";
    		else if( opcao == 1 )hotel = "Hotel G1";
    		else{
    			rete_print.executeCommand("(printout t \"escolha uma opcao valida\n\")");
				continue;
    		}
    		
    		break;
    		
        }
        
		rete_print.executeCommand("(printout t \"\n\")");
		
		rete_print.executeCommand("(printout t \"Quanto voc pretende gastar pela sua viagem?: R$ \")");
		capital = c.readDouble();
		
		rete_print.executeCommand("(printout t \"\n\")");
		
		cliente = new Cliente(nome,destino,data_ida,data_volta,capital,city_tour,tempoPartida,tempoChegada,hotel,transporte);
		
		c.println("Sr. "+ cliente.getNome() + ",");
		rete_print.executeCommand("(printout t \"Aguarde alguns instantes, estamos produzimos o seu programa de viagem completo...\n\n\")");	
	}
	
	public int processaRegras() throws JessException{
		double custo_destino,custo_hotel,custo_transporte,custo_tour;
		
		if(cliente.isCity_tour()) custo_tour = 10000;
		else                      custo_tour = 0;
		
	    rete_process.executeCommand("(deffacts data" +
	    	               "(destino perto \"Rio de Janeiro\" 500)" +
	                       "(destino longe \"New York\" 4000)" +
	                       "(destino longe \"Washington\" 3000 )" +
	                       "(destino medio \"Caribe\" 5000)" +
	                       "(destino perto \"Olinda\" 100)" +
	                       "(destino longe \"Paris\" 7000)" +
	                       "(destino longe \"Londres\" 6500)" +
	                       "(destino longe \"Ilhas Cayman\" 5000)" +
	                       "(destino longe \"Tokio\" 10000))");
	    
	    rete_process.executeCommand("(defquery search (declare (variables ?Y)) (destino ?X ?Y ?Z))");
	    
	    rete_process.reset();
	    // Roda as querys e guarda o resultado
	    rete_process.store("RESULT", rete_process.runQuery("search",
	                      new ValueVector().add(new Value("\"" + cliente.getDestino()+ "\"", RU.ATOM))));
	     
	    rete_process.executeCommand("(store RESULT (run-query search "+ "\""+cliente.getDestino()+"\""+ "))");

	    // Guarda o resultado no Iterator
	    Iterator e = (Iterator) rete_process.fetch("RESULT").externalAddressValue(null);
	    ArrayList v = new ArrayList();

	      
	    // Pega cada elemento do Iterator e armazena num ArrayList
	    while (e.hasNext()){
	        Token t = (Token) e.next();
	        // Pega o segundo fato no Token - O primeiro  a query trigger
	        Fact f = t.fact(1);
	        // O Primeiro e unico slot deste fato  o __data multislot.
	        ValueVector multislot = f.get(0).listValue(null);
	        //O segundo elemento deste slot  o datum, estamos interessados nele.
	        v.add(multislot.get(2).stringValue(null));
	    }
	    
	    Iterator answers = v.iterator();
	   
	    custo_destino = Double.parseDouble(answers.next().toString());
	    
	    rete_process.executeCommand("(deffacts data" +
	               "(hotel \"Hotel G1\" 200)" +
                "(hotel \"Hotel G2\" 500)" +
                "(hotel \"Hotel G3\" 2000)" +
                "(hotel \"Hotel G4\" 10000)" +
                "(hotel \"Hotel G5\" 50000))");
	    
	    rete_process.executeCommand("(defquery search (declare (variables ?X)) (hotel ?X ?Y))");
	    
	    rete_process.reset();
	    
	    // Roda as querys e guarda o resultado
	    rete_process.store("RESULT", rete_process.runQuery("search",
	                      new ValueVector().add(new Value("\"" + cliente.getHotel()+ "\"", RU.ATOM))));
	     
	    rete_process.executeCommand("(store RESULT (run-query search "+ "\""+cliente.getHotel()+"\""+ "))");

	    // Guarda o resultado no Iterator
	    e = (Iterator) rete_process.fetch("RESULT").externalAddressValue(null);
	    v = new ArrayList();

	      
	    // Pega cada elemento do Iterator e armazena num ArrayList
	    while (e.hasNext()){
	        Token t = (Token) e.next();
	        // Pega o segundo fato no Token - O primeiro  a query trigger
	        Fact f = t.fact(1);
	        // O Primeiro e unico slot deste fato  o __data multislot.
	        ValueVector multislot = f.get(0).listValue(null);
	        //O segundo elemento deste slot  o datum, estamos interessados nele.
	        v.add(multislot.get(1).stringValue(null));
	    }
	    
	    answers = v.iterator();
	    custo_hotel = Double.parseDouble((answers.next().toString()));
	    
	    
	    rete_process.executeCommand("(deffacts data" +
	         "(transporte Navio 5000)" +
	         "(transporte Trem 300)" +
	         "(transporte Carro 2000)" +
	         "(transporte Balsa 10000)" +
	         "(transporte Motocicleta 1000)" +
	         "(transporte Aviao 7000)" +
	         "(transporte Helicoptero 12000)" +
	         "(transporte Planador 15000)" +
	         "(transporte Balao 20000)" +
	         "(transporte Dirigivel 50000))");
	         
	    rete_process.executeCommand("(defquery search (declare (variables ?X)) (transporte ?X ?Y))");
	    
	    rete_process.reset();
	    
	    // Roda as querys e guarda o resultado
	    rete_process.store("RESULT", rete_process.runQuery("search",
	                      new ValueVector().add(new Value(cliente.getTransporte(), RU.ATOM))));
	     
	    rete_process.executeCommand("(store RESULT (run-query search "+ cliente.getTransporte()+"))");

	    // Guarda o resultado no Iterator
	    e = (Iterator) rete_process.fetch("RESULT").externalAddressValue(null);
	    v = new ArrayList();

	      
	    // Pega cada elemento do Iterator e armazena num ArrayList
	    while (e.hasNext()){
	        Token t = (Token) e.next();
	        // Pega o segundo fato no Token - O primeiro  a query trigger
	        Fact f = t.fact(1);
	        // O Primeiro e unico slot deste fato  o __data multislot.
	        ValueVector multislot = f.get(0).listValue(null);
	        //O segundo elemento deste slot  o datum, estamos interessados nele.
	        v.add(multislot.get(1).stringValue(null));
	    }
	    
	    answers = v.iterator();
	    custo_transporte = Double.parseDouble((answers.next().toString()));
	    
	    
	    if(custo_destino + custo_hotel + custo_transporte + custo_tour <= cliente.getCapital()){
	    	cliente.setProposta(custo_destino + custo_hotel + custo_transporte + custo_tour);
	    	return 1; 
	    }
	    return 0;
	    
	}
	
	public void geraRelatorioSucesso() throws JessException{
		
		c.println("Programa Criado com sucesso! Muito Obrigado pela preferencia!\n");
		c.print("Pressione ENTER para exibi-lo");	
		c.readChar();
		
		c.print("\n");
		
		c.println("Local de Destino : " + cliente.getDestino());
		c.println("Data de Partida : " + cliente.getData_ida());
		c.println("Data de Chegada : " + cliente.getData_volta());
		
		c.println("Transporte mais indicado para viagem : " + cliente.getTransporte());
		
		if(cliente.isCity_tour()){
			c.println("O Cliente deseja realizar City Tour!");
		}
		else{
			c.println("O Cliente no deseja realizar City Tour!");
		}
		c.println("O Hotel mais indicado para hospedagem  : " + cliente.getHotel());
		
		c.println("O cliente possui um capital de : R$" + format.format(cliente.getCapital()));
		c.println("A nossa proposta vai custar : R$" + format.format(cliente.getProposta()));
		c.print("\n");
	}
	
	public void geraRelatorioAjustado() throws JessException{
		
		c.println("Infelizmente voc no possui recurso suficiente para toda sua viagem.");
		c.println("Assim, elaboramos um programa de viagem baseado nos seus recursos,");
		c.println("de forma que voc aproveite ao maximo, dentro do seu oramento.\n");
		c.println("Muito Obrigado pela preferencia!\n");
		c.println("Pressione ENTER para exibir o programa de viagem");	
		c.readChar();
		
		c.print("\n");
		
		if(!cliente.isChega_destino())c.println("No h recurso para o destino solicitado!");
		
		c.println("Local de Destino : " + cliente.getDestino());
		c.println("Data de Partida : " + cliente.getData_ida());
		c.println("Data de Chegada : " + cliente.getData_volta());
		
		c.println("Transporte mais indicado para viagem : " + cliente.getTransporte());
		
		if(cliente.isCity_tour()){
			c.println("O Cliente realiza um City Tour!");
		}
		else{
			c.println("O Cliente no realiza City Tour!");
		}
		
		c.println("O Hotel mais indicado para hospedagem  : " + cliente.getHotel());
		
		c.println("O cliente possui um capital de : R$" + format.format(cliente.getCapital()));
		c.println("A nossa proposta vai custar : R$" + format.format(cliente.getProposta()));
		
		c.println("");
	}

	public void geraRelatorioSemRecurso() throws JessException{
		
		c.println("O cliente possui um capital de : R$" + format.format(cliente.getCapital()));
		c.println("Infelizmente voc no possui recurso suficiente realizar nenhuma viagem com a nossa agncia.");
		c.println("Procure-nos quando estiver numa situao melhor!");
		c.println("Muito Obrigado pela preferencia!\n");
		c.println("Pressione ENTER para sair");	
		c.readChar();
		
	}

    public static void main(String [] argv) throws JessException{
    	
        try{
	        Agencia agencia = new Agencia();
	       
	        agencia.apresentaAgencia();
	        agencia.carregaRegras();
	       	agencia.lerDados();
	       	
	        if( agencia.processaRegras() == 1 ){
	        	agencia.geraRelatorioSucesso();
	        }
	        else{
	        	if( agencia.knapsack_jess() != -1 )   	agencia.geraRelatorioAjustado();
	        	else{
	        		agencia.geraRelatorioSemRecurso();
	        	}
	        }
	        
	    }
	    catch (JessException e){
	        e.printStackTrace();
	    }
    }
}
