package jess;

import java.util.Map;
/**
 * Things that can be grouped on the LHS of a rule; either patterns,
 * or groups of patterns.
 */

interface Groupable {
    String getName();
    void setBoundName(String name) throws JessException;
    void setUnique();
    void setExplicit();
    void setLogical();
    boolean getLogical();
    void addToLHS(HasLHS l, Rete engine) throws JessException;
    Groupable simplify() throws JessException;
    int getGroupSize();
    Groupable getGroupable(int i);        
    boolean getBackwardChaining();
    void flattenToGroup(Group g, int negcnt) throws JessException;
    void addDirectlyMatchedVariables(Map map) throws JessException;
    void renameUnmentionedVariables(Map map, Map subs, int size)
        throws JessException;
}
