; -*- jess -*-

;; Jess standard script library
;; You can add functions to this file and they will be loaded in whenever
;; Jess starts up
;; (C) 1997 E.J.Friedman-Hill and Sandia National Laboratories


(deffunction show-deftemplates ()
  "Print deftemplates using Java reflection"
  (bind ?__e (call (engine) listDeftemplates))
  (while (call ?__e hasNext)    
      (printout t crlf
          (call (new jess.PrettyPrinter (call ?__e next)) toString) crlf)))

(deffunction show-jess-listeners ()
  "Print JessListeners using Java reflection"
  (bind ?__e (call (engine) listJessListeners))
  (while (call ?__e hasNext)    
    (printout t crlf (call (call ?__e next) toString) crlf)))

(deffunction show-deffacts ()
  "Print deffacts using Java reflection"
  (bind ?__e (call (engine) listDeffacts))
  (while (call ?__e hasNext)    
    (printout t crlf (call (new jess.PrettyPrinter (call ?__e next)) toString)
               crlf)))

(deffunction ppdefrule (?__rule)
  "Pretty-print a Jess rule"
  (bind ?__rule (call (engine) findDefrule ?__rule))
  (call (new jess.PrettyPrinter ?__rule) toString))


(deffunction ppdeffacts (?__deffacts)
  "Pretty-print a Jess rule"
  (bind ?__deffacts (call (engine) findDeffacts ?__deffacts))
  (call (new jess.PrettyPrinter ?__deffacts) toString))

(deffunction ppdefquery (?__query)
  "Pretty-print a Jess query"
  (ppdefrule ?__query))

(deffunction ppdeffunction (?__function)
  "Pretty-print a Jess function"
  (bind ?__function (call (engine) findUserfunction ?__function))
  (call (new jess.PrettyPrinter ?__function) toString))

(deffunction ppdefglobal (?__global)
  "Pretty-print a Jess global"
  (bind ?__global (call (engine) findDefglobal ?__global))
  (call (new jess.PrettyPrinter ?__global) toString))

(deffunction ppdeftemplate (?__template)
  "Pretty-print a Jess template"
  (bind ?__template (call (engine) findDeftemplate ?__template))
  (call (new jess.PrettyPrinter ?__template) toString))

(deffunction fact-slot-value (?__fact ?__name)
  "Fetch the value from the named slot of the given fact"
  (return (call ?__fact getSlotValue ?__name)))

(deffunction run-until-halt ()
  "Run until halt is called."
  (call (engine) runUntilHalt))

